function bisection_algorithm
clc
clear all
close all

%% Parameters
f=@(x) x^3+2*x^2-3*x-1;  %function
a=1;   %left bound
b=2;   %right bound
ee=1e-10;   % error tolerance
Nmax=500; %maximum iteratoins  THORETICAL VALUE  Nmax=log((b-a)/ee)*log(1/2)+1;

%% Algorithm
sfa=sign(feval(f,a));
k=0;          %Starting the Iteration counter
fprintf('Starting Calculatins \n ----------------------\n k\t   a\t\t\t  b\n')
fprintf('%3.f \t %1.10f\t %1.10f \n',k,a,b)
while (b-a)>2*ee    %stopping criteria
    p=a+(b-a)/2;
    sfp=sign(feval(f,p));
    if (sfa*sfp)<0
          b=p;
    else
         a=p;
         sfa=sfp;
    end
       if k>Nmax   %stopping criteria for max iterations
             fprintf('\n\n\n!!!!Max Iterations Reached!!!!!!!\n') 
               break
        end
        k=k+1;
  fprintf('%3.f \t %1.10f\t %1.10f \n',k,a,b)
end
 if k<Nmax
             fprintf('\nRoot=%20.10f\n',p)
 end
end
