function Newton_algorithm
clc
clear all
close all

%% Parameters
f=@(x) x^3+2*x^2-3*x-1;  % function
dd=1;    % if haveyou have the dd =1; If DONT have dd=0
d=@(x) 3*x^2+4*x-3;   % first derivative
a=1;   %Intial Guess 
ee=1e-10;   % error tolerance
Nmax=50; %maximum iteratoins 

%% Calculating The Derivative
if dd<0.5
syms x
t=diff(f,x);
d=matlabFunction(t);
end

%% Algorithm
k=0; %Iteration counter
fprintf('Starting Calculatins \n ----------------------\n k\t   x_n\n')
p=a; m=feval(f,p); md=feval(d,p);
pp=2.32; X=10;
while X>ee
     fprintf('\n%3.f \t %1.10f',k,p)
    p=p-m/md;
     m=feval(f,p); md=feval(d,p);
    X=abs(p-pp);  % error calculation for stopping
    pp=p;   %pp=p(n)
       if k>Nmax
             fprintf('\n\n\n!!!!Max Iterations Reached!!!!!!!\n') 
               break
        end
   k=k+1;
end
 if k<Nmax
             fprintf('\n\nRoot=%20.10f\n',p)
 end
end
