function false_position_algorithm
clc
clear all
close all

%% Parameters
f=@(x) x^3+2*x^2-3*x-1;  %function
a=1;   %left bound
b=2;   %right bound
ee=1e-10;   % error tolerance
Nmax=500; %maximum iteratoins

%% Algorithm
k=0; %Start the Iteration counter   
pp=1.2; ppp=12; X=13;
sfa=sign(feval(f,a));
fprintf('Starting Calculatins \n ----------------------\n k\t   a\t\t\t  b\n')
fprintf('%3.f \t %1.10f\t %1.10f \n',k,a,b)
while X>ee
    bb=feval(f,b);
    aa=feval(f,a);
    p=b-bb*(b-a)/(bb-aa);
    sfp=sign(feval(f,p));
    if (sfa*sfp)<0
          b=p;
    else
         a=p;
         sfa=sfp;
    end
    pppp=ppp; %pppp=p(n-2)
    ppp=pp;  %ppp=p(n-1)
    pp=p;   %pp=p(n)
    hh=(pp-ppp)/(ppp-pppp);  %lambda
    X=abs(hh/(hh-1))*abs(pp-ppp);  % error calculation for stopping
        if k>Nmax     %stopping criteria for max iterations
             fprintf('\n\n\n!!!!Max Iterations Reached!!!!!!!\n') 
               break
        end
        k=k+1;
  fprintf('%3.f \t %1.10f\t %1.10f \n',k,a,b)
end
 if k<Nmax
             fprintf('\nRoot=%20.10f\n',p)
 end
end